package starzi.kvf;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

class MissingItem extends KVItem {
	
	static final KVItem INSTANCE = new MissingItem();
	
	private MissingItem() {}
	
	/**
	 * throws UnsupportedOperationException
	 */
	public void setParent(KVItem item) {
		throw new UnsupportedOperationException("Missing Item");
	}
	
	/**
	 * Always returns false.
	 */
	public boolean exists() {
		return false;
	}
	
	/**
	 * Returns the missing item
	 */
	public MissingItem getParent() {
		return this;
	}
	
	/**
	 * throws UnsupportedOperationException
	 */
	public void addChild(KVItem item) {
		throw new UnsupportedOperationException("Missing Item");
	}
	
	/**
	 * throws UnsupportedOperationException
	 */
	public void removeChild(KVItem item) {
		throw new UnsupportedOperationException("Missing Item");
	}
	
	/**
	 * Returns the missing item
	 */
	public MissingItem getChildWithKey(String key) {
		return this;
	}
	
	/**
	 * Returns the missing item
	 */
	public MissingItem getChildWithValue(String key, String value) {
		return this;
	}
	
	/**
	 * Returns an empty list
	 */
	public List<KVItem> getChildrenWithKey(String key) {
		return Collections.emptyList();
	}
	
	/**
	 * Returns an empty list
	 */
	public List<KVItem> getChildrenWithValue(String key, String value) {
		return Collections.emptyList();
	}
	
	/**
	 * throws UnsupportedOperationException
	 */
	public MissingItem getChild(int index) {
		throw new UnsupportedOperationException("Missing Item");
	}
	
	/**
	 * Returns false
	 */
	public boolean hasChildren() {
		return false;
	}
	
	/**
	 * Returns 0
	 */
	public int getChildCount() {
		return 0;
	}
	
	/**
	 * Returns an empty list
	 */
	public Collection<KVItem> getChildren() {
		return Collections.emptyList();
	}
	
	/**
	 * throws UnsupportedOperationException
	 */
	public void add(String key) {
		throw new UnsupportedOperationException("Missing Item");
	}
	
	/**
	 * throws UnsupportedOperationException
	 */
	public void set(String key, String value) {
		throw new UnsupportedOperationException("Missing Item");
	}
	
	/**
	 * Returns false
	 */
	public boolean has(String key) {
		return false;
	}
	
	/**
	 * Returns false
	 */
	public boolean has(String key, String value) {
		return false;
	}
	
	/**
	 * Returns the missing pair
	 */
	public KVPair get(String key) {
		return KVPair.MISSING_PAIR;
	}
	
	/**
	 * throws UnsupportedOperationException
	 */
	public void remove(String key) {
		throw new UnsupportedOperationException("Missing Item");
	}
	
	/**
	 * Returns an empty list
	 */
	public Collection<KVPair> getValues() {
		return Collections.emptyList();
	}
	
	/**
	 * Returns "< MissingItem >"
	 */
	public String toString() {
		return "< MissingItem >";
	}
	
	/**
	 * Returns "< MissingItem >"
	 */
	public String deepToString() {
		return "< MissingItem >";
	}
	
	/**
	 * throws UnsupportedOperationException
	 */
	public void writeToFile(File file) throws FileNotFoundException {
		throw new UnsupportedOperationException("Missing Item");
	}
	
}