package starzi.kvf;

class MissingPair extends KVPair {
	
	static final KVPair INSTANCE = new MissingPair();
	
	private MissingPair() {
		super("", "");
	}
	
	public boolean exists() {
		return false;
	}
	
	public String getKey() {
		return "";
	}
	
	/**
	 * Returns the value of this item as String.
	 * If the item had no value associated within the document then this method will return an empty String.
	 * This method will never return null.
	 * @return
	 */
	public String asString() {
		return "";
	}
	
	public String asString(String defaultValue) {
		return defaultValue;
	}
	
	public boolean asBoolean() throws FormatException {
		throw new FormatException(asString()+" can not be parsed to boolean.");
	}
	
	/**
	 * This method will try to parse the value of this item to a boolean.
	 * If the parsing fails because the value does not represent a boolean then the defaultValue will be returned.
	 * @param defaultValue
	 * @return
	 */
	public boolean asBoolean(boolean defaultValue) {
		return defaultValue;
	}
	
	public byte asByte() {
		throw new FormatException(asString()+" can not be parsed to byte.");
	}
	
	/**
	 * This method will try to parse the value of this item to a byte.
	 * If the parsing fails because the value does not represent a byte then the defaultValue will be returned.
	 * @param defaultValue
	 * @return
	 */
	public byte asByte(byte defaultValue) {
		return defaultValue;
	}
	
	public short asShort() {
		throw new FormatException(asString()+" can not be parsed to byte.");
	}
	
	/**
	 * This method will try to parse the value of this item to a short.
	 * If the parsing fails because the value does not represent a short then the defaultValue will be returned.
	 * @param defaultValue
	 * @return
	 */
	public short asShort(short defaultValue) {
		return defaultValue;
	}
	
	public int asInt() {
		throw new FormatException(asString()+" can not be parsed to byte.");
	}
	
	/**
	 * This method will try to parse the value of this item to an int.
	 * If the parsing fails because the value does not represent an int then the defaultValue will be returned.
	 * @param defaultValue
	 * @return
	 */
	public int asInt(int defaultValue) {
		return defaultValue;
	}
	
	public long asLong() {
		throw new FormatException(asString()+" can not be parsed to byte.");
	}
	
	/**
	 * This method will try to parse the value of this item to a long.
	 * If the parsing fails because the value does not represent a long then the defaultValue will be returned.
	 * @param defaultValue
	 * @return
	 */
	public long asLong(long defaultValue) {
		return defaultValue;
	}
	
	public float asFloat() {
		throw new FormatException(asString()+" can not be parsed to byte.");
	}
	
	/**
	 * This method will try to parse the value of this item to a float.
	 * If the parsing fails because the value does not represent a float then the defaultValue will be returned.
	 * @param defaultValue
	 * @return
	 */
	public float asFloat(float defaultValue) {
		return defaultValue;
	}
	
	public double asDouble() {
		throw new FormatException(asString()+" can not be parsed to byte.");
	}
	
	/**
	 * This method will try to parse the value of this item to a double.
	 * If the parsing fails because the value does not represent a double then the defaultValue will be returned.
	 * @param defaultValue
	 * @return
	 */
	public double asDouble(double defaultValue) {
		return defaultValue;
	}
	
	/**
	 * This method will try to parse the value of this item into an enum of the same type as the given defaultValue.
	 * If the parsing fails because the value does not represent any enum of that type then the defaultValue will be returned.
	 * @param defaultValue
	 * @throws NullPointerException when defaultValue is null.
	 * @return
	 */
	public Enum<?> asEnum(Enum<?> defaultValue) {
		return defaultValue;
	}
	
	public Enum<?> asEnum(Class<Enum<?>> enumClass) {
		throw new FormatException(asString()+" can not be parsed into "+enumClass.getSimpleName());
	}
	
	/**
	 * Returns this pair in the following format:
	 * < getKey() := getValue() >
	 */
	public String toString() {
		return "< MissingPair >";
	}
	
	/**
	 * Returns an exact clone of this pair.
	 */
	public KVPair clone() {
		return this;
	}
	
}