package starzi.kvf.tests;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

import starzi.kvf.KVFParser;
import starzi.kvf.KVItem;

public class TestCities {
	
	public static void main(String[] args) throws FileNotFoundException {
		KVFParser parser = new KVFParser(new File("Documents/Places.kvf"));
		KVItem doc = parser.parse();
		
		System.out.println(doc.deepToString());
		System.out.println();
		
		KVItem capitalOfFrance = doc.getChildWithKey("france").getChildWithKey("capital");
		System.out.println("Capital of France:");
		System.out.println(capitalOfFrance);
		
		KVItem capitalOfGermany = doc.getChildWithKey("GerMany").getChildWithKey("capital");
		System.out.println("Capital of Germany:");
		System.out.println(capitalOfGermany);
		
		KVItem capitalOfItaly = doc.getChildWithKey("Italy").getChildWithKey("capital");
		System.out.println("Capital of Italy:");
		System.out.println(capitalOfItaly);
		
		KVItem capitalOfBritain = doc.getChildWithKey("Britain").getChildWithKey("capital");
		System.out.println("Capital of Britain:");
		System.out.println(capitalOfBritain);
		
		List<KVItem> europeanCountries = doc.getChildrenWithKey("europe");
		System.out.println("European Countries:");
		System.out.println(europeanCountries);
		
		List<KVItem> capitalsOfNonEuropeanCountries = new ArrayList<>();
		for (KVItem countryAsItem : doc.getChildren()) {
			if (!countryAsItem.has("europe")) {
				capitalsOfNonEuropeanCountries.addAll(countryAsItem.getChildrenWithKey("capital"));
			}
		}
		System.out.println("Capitals of Non-European Countries:");
		System.out.println(capitalsOfNonEuropeanCountries);
		
		List<KVItem> capitalsOfAfricanCountries = new ArrayList<>();
		for (KVItem countryAsItem : doc.getChildren()) {
			if (countryAsItem.has("africa")) {
				capitalsOfAfricanCountries.addAll(countryAsItem.getChildrenWithKey("capital"));
			}
		}
		System.out.println("Capitals of African Countries:");
		System.out.println(capitalsOfAfricanCountries);
	}
	
}