package starzi.kvf.tests;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

import starzi.kvf.KVFParser;
import starzi.kvf.KVItem;

public class TestRPGHero {
	
	public static void main(String[] args) throws FileNotFoundException {
		KVFParser parser = new KVFParser(new File("Documents/RPGHero.kvf"));
		KVItem doc = parser.parse();
		
		KVItem heroAsItem = doc.getChildWithKey("hero");
		String heroName = heroAsItem.get("name").asString();
		double heroHp = heroAsItem.get("hp").asDouble();
		double heroMp = heroAsItem.get("mp").asDouble();
		int heroStr = heroAsItem.get("str").asInt();
		int heroDef = heroAsItem.get("def").asInt();
		
		List<String> heroItems = new ArrayList<>();
		for (KVItem itemAsItem : heroAsItem.getChildrenWithKey("item")) {
			heroItems.add(itemAsItem.get("id").asString());
		}
		
		PrintStream out = System.out;
		
		out.println(heroName);				// => Awesome McCool
		out.println("Hp: "+heroHp);			// => Hp: 512.67
		out.println("Mp: "+heroMp);			// => Mp: 256.34
		out.println("Str: "+heroStr);		// => Str: 128
		out.println("Def: "+heroDef);		// => Def: 64
		out.println("Items: "+heroItems);	// => Items: [longsword, buckler, chainmail, potionofHealing]
	}
	
}